/* Layer revu

@author = DFO Team
@lastModificationsBy = Flo
@information = "Ce layer est censé reprendre les fonctionnalités diverses des X layers présents précédemment et de les factoriser,
	si toutefois vous recensiez un bug merci de me le remonter, l'idée est d'avoir un layer unique la prochaine étape consistera
	à l'optimiser"

Appel du layer sur la methode showLayer de la manière suivante selon les cas :

 - cas standard : oLayer.showLayer(null, '___id___du___layer___a___afficher___');
	---> on ouvre le layer spécifié

 - cas message erreur / attention : oLayer.showLayer('___ma___string___', '___id___du___layer___a___afficher___');
	---> on met le texte dans une zone prévue à cet effet dans le layer

 - cas indisponibilité : oLayer.showLayer(this, '___id___du___layer1___a___afficher___') sur lien en question;
	---> on affiche le layer indisponibilité en changeant le titre selon le "title" du a


... to continue...
	
*/

var Layer = Class.create();
Layer.prototype = {
	initialize: function() {
		var _self = this;
		this.fog = $('fog');
		if (!this.fog.className.match(/\bclose\b/)) this.fog.className += 'close';
        this.observeTogglePopup('a.popup');
        //this.observeToggleMail('a.mail');
        this.observePopupClose('.close');
        this.observeToggleLink('a.toggle');
        this.observeTriggerHelper('a.helper');
        this.resizeBlocks('div.cell-phone');
		
		this.slideshowLaunchers = $$('a.slideshow');
		
		
		this.IMG = $('diapoImg');
		this.diapoCounter = $('diapoCounter');
		this.zoom = $$('a.zoomLink')[0];
		if (this.slideshowLaunchers.length >0){
			
			this.prev = $('slideShowPrev');
			this.next = $('slideShowNext');
			// diapo voir fiche mobile rm
			if(this.slideshowLaunchers.length > 1){
				this.slideshowLaunchers.each(function(el,i){
					el.setAttribute("index", i);
					el.observe("click", function(e){
						Event.stop(e);
						_self.setImage(this.getAttribute("rel"), this.getAttribute("index"), this);
					});
				});
				this.prev.observe('click', function(){
					var ind = this.href.split("#")[1];
					_self.setImage(_self.slideshowLaunchers[ind].rel, ind, this);
				});
				this.next.observe('click', function(){
					var ind = this.href.split("#")[1];
					_self.setImage(_self.slideshowLaunchers[ind].rel, ind, this);
				});
			}else{
				this.prev.style.visibility = 'hidden';
				this.next.style.visibility = 'hidden';
			}
		}
		
		
	},

	observeTriggerHelper: function(selector) {
		$$(selector).each(function(el){
			if(el.rel != '')
				new Tip(el, el.rel, {skin:'default', title:'&nbsp;'});
		});
	},

	resizeBlocks: function(selector) {
		var i = 1;
		var tmp = [];
		var maxHeight = 0;
		var cells = $$(selector);
		var count = cells.length;
		cells.each(function(el){
			tmp.push(el);
			if(i%3==0 || i==count)
			{
				tmp.each(function(e){
					if(e.getHeight()>maxHeight) maxHeight = e.getHeight();
				});
				tmp.each(function(e){
					e.setStyle({'height':maxHeight+'px'});
				});
				tmp=[];
				maxHeight=0;
			}
			i++;
		});
	},

	observeToggleLink: function(selector) {
		$$(selector).each(function(el){
			el.observe('click', function(evt) {
				Event.stop(evt);
				var target = el.href.split('#').last();
				if ($(target)) $(target).toggle();
			});
		});
	},

	observePopupClose: function(selector) {
		var me=this;
		$$(selector).each(function(el){
			el.observe('click', function(evt) {
				Event.stop(evt);
				me.setDisplayPopup(null, el);
			});
		});
	},

	observeTogglePopup: function(selector) {
		var me=this;
		$$(selector).each(function(el){
			el.observe('click', function(evt) {
				Event.stop(evt);
				me.setMessagePopup('Ceci est un test.');
				me.setPositionPopup();
				me.setDisplayPopup();
			});
		});
	},
  
	observeToggleMail: function(selector) {
		var me=this;
		$$(selector).each(function(el){
			el.observe('click', function(evt) {
				Event.stop(evt);
				me.setPositionPopup();
				me.setDisplayPopup();
			});
		});
	},
	setImage: function (src, i, a){
		this.IMG.src = src;
		i = parseInt(i);
		$('slideShowPrev').href = "#"+(i - 1);
		$('slideShowNext').href = "#"+(i + 1);
		if (i == 0){
			this.prev.style.visibility = "hidden";
			this.next.style.visibility = "visible";
		}
		if (i < this.slideshowLaunchers.length - 1 && i>0){
			this.prev.style.visibility = "visible";
			this.next.style.visibility = "visible";
		}
		if (i == this.slideshowLaunchers.length - 1){
			this.next.style.visibility = "hidden";
		}
		this.diapoCounter.innerHTML = "Photo "+(i+1)+" sur "+this.slideshowLaunchers.length;
	},
	setDisplayPopup: function(layer, link) {
		this.layer = layer ? $(layer) : this.layer;
		if(!this.layer && link && link.nodeName=='A' && link.className.match(/\bclose\b/)) {
			this.layer = $(link.href.match(/\#(.+)$/)[1]);
		}
        if (this.layer) {
            this.fog.toggle();
            this.layer.toggle();
            this.setPositionPopup(this.layer);
        }
	},

	setPositionPopup: function(layer) {
		var height = layer.getHeight();
		var htmlHeight = document.documentElement.offsetHeight;
		var scrollTop = document.documentElement.scrollTop;
		if (typeof document.body.style.maxHeight != "undefined") {
			layer.setStyle({marginTop: '-' + parseInt((height / 2)+4) + 'px'});
		} else{
			layer.setStyle({marginTop: (scrollTop + 150) +'px', top:0 + 'px'});
		}
	},
    
	setMessagePopup: function(string) {
		$('customError').update(string);
	},
	setConfirmPopup : function(){
		var me = this;
						
		$('contentLayerAlerte').hide();
		$('alerte-confirm').show();
		$('restart-div').show();
	},
	showLayer : function(el, oShow){
		var mode = typeof el === 'object' ? 1 : 0;
		if (mode == 1 && el != null){
			//mode specifique d'alertes disponibilités
			$('alerte-pp').value=el.id;
			$('productLayerAlerte').update(el.title);
			$('productLayerAlerte').innerHTML;
			$('contentLayerAlerte').show();
			$('alerteerror').update('');
			$('alerte-confirm').hide();
			$('restart-div').hide();
			this.setDisplayPopup(oShow);
		}else if(mode == 0){
			this.setMessagePopup(el);
            this.setDisplayPopup(oShow);
		}else if (el == null){
			this.setDisplayPopup(oShow);
		}
		
	}
}
var oLayer = null;
Event.observe(window, 'load', function() { oLayer = new Layer(); });


